#ifndef _PCI_H_
#define _PCI_H_




struct PCI_config_space
{
    unsigned short int VendorID;
    unsigned short int DeviceID;
    unsigned short  int Command;
    unsigned short  int Status;
    unsigned char	Reversion_id ;
    unsigned char	ProgIf ;
    unsigned char	SubClass ;
    unsigned char	BaseClass ;
    unsigned char Cache_Line_Size ;
    unsigned char LastTime;
    unsigned char HEADERType;
    unsigned char BIST;
};

struct PCI_config_space_0
{
    unsigned short VendorID;
    unsigned short DeviceID;
    unsigned short Command;
    unsigned short Status;
    unsigned int Classcode_Revision_ID;
    unsigned char Cache_Line_Size ;
    unsigned char LastTime;
    unsigned char HEADERType;
    unsigned char BIST;
    
    unsigned int BAR0;
    unsigned int BAR1;
    unsigned int BAR2;
    unsigned int BAR3;
    unsigned int BAR4;
    unsigned int BAR5;
    unsigned int CarsbusCIS;
    unsigned short SubVendorID;
    unsigned short SubSystemID;
    unsigned int ROM_Base_adress;
    
    
    unsigned int Cap_pointer_Reserved;
    unsigned int Reserved1;
    
    unsigned char INIT_Line;
    unsigned char INIT_Pin;
    unsigned char Min_gnt;
    unsigned char Max_lat;
};
struct PCI_config_space_1
{
    unsigned short VendorID;
    unsigned short DeviceID;
    unsigned short Command;
    unsigned short Status;
    unsigned int Classcode_Revision_ID;
    unsigned char Cache_Line_Size ;
    unsigned char LastTime;
    unsigned char HEADERType;
    unsigned char BIST;
    
    unsigned int BAR0;
    unsigned int BAR1;
    unsigned char Primary_bus_No;
    unsigned char Secondary_bus_No ;
    unsigned char Subordinate_bus_No;
    unsigned char Secondary_latency_timer ;
    unsigned char I_O_base ;
    unsigned char I_O_Limit ;
    unsigned short Secondary_Status ;
    unsigned short Memory_base ;
    unsigned short Memory_limit ;
    unsigned short Prefetchable_memory_base ;
    unsigned short Prefetchable_memory_limit ;
    unsigned int Prefetchable_base_upper_32_bits ;
    unsigned int Prefetchable_limit_upper_32_bits ;
    unsigned short I_O_base_upper_16_bits ;
    unsigned short I_O_limit_upper_16_bits ;
    unsigned int Reserviert_Capabilities_pointer ;
    unsigned int Extension_ROM_base_address ;
    unsigned char Interrupt_line ;
    unsigned char Interrupt_pin ;
    unsigned short Bridge_control; 

};




/*
1  	Register verwenden?  	ENABLE DISABLE
2 	Gre des Adressraums 	SIZE2G SIZE1G SIZE512M SIZE256M SIZE128M SIZE64M SIZE32M SIZE16M SIZE8M SIZE4M SIZE2M SIZE1M SIZE512K SIZE256K SIZE128K SIZE64K SIZE32K SIZE16K SIZE8K SIZE4K SIZE2K SIZE1K SIZE512 SIZE256 SIZE128 SIZE64 SIZE32 SIZE16
3 	Prefetchbarer Speicher? 	PREFETCH NOFETCH IO_PREFETCH
4 	Einordnung im Gesamtadressraum und Registerbreite 	TYPE00 (TYPE01) TYPE10 IO_TYPE
5 	IO- oder Speicheradressraum 	IO MEMORY
*/


struct PCI_Class_space
{
     unsigned char	Reversion_id ;
     unsigned char	ProgIf ;
     unsigned char	SubClass ;
     unsigned char	BaseClass ;
};



#define PCI_BAR_Enable(Data) (Data & 0x1)
#define PCI_BAR_Len(Data) (Data & 0x2)
#define PCI_BAR_PREFETCH(Data) (Data & 0x4)
#define PCI_BAR_TYPE(Data) (Data & 0x8)
#define PCI_BAR_Speicheradressraum(Daten) Daten & 0xFFFFFFF0




	
#define PCI_GetRegisternummer(Adresse) ((Adresse>>2)& 0x3f)
#define PCI_GetFunctionnummer(Adresse) ((Adresse>>8)& 0x7)
#define PCI_GetDevicenummer(Adresse) ((Adresse>>11)& 0x1F)
#define PCI_GetBusnummer(Adresse) ((Adresse>>16)& 0xFF)



#define PORT_Addresse			0xCF8
#define PORT_Data			    0xCFC
#define PCIBus_Dev_not			0xFFFFFFFF
#define PCIBus_adresse			0x80000000
#define PCIBus_Countadr		    0x100
#define PCIBus_Endadr	    	0x80FFFF00

#define Header_types_Standard 0x0
#define Header_types_PCI_to_PCI_Bridge 0x1
#define Header_types_Card_Bus_Bridge 0x2





typedef struct _PCI_CLASSCODETABLE
{
	unsigned char	BaseClass ;
	unsigned char	SubClass ;
	unsigned char	ProgIf ;
	char *		BaseDesc ;
	char *		SubDesc ;
	char *		ProgDesc ;
}  PCI_CLASSCODETABLE, *PPCI_CLASSCODETABLE ;

PCI_CLASSCODETABLE PciClassCodeTable [] =
{
	{ 0x00, 0x00, 0x00, "Pre-2.0 PCI Specification Device", "Non-VGA","" } ,
	{ 0x00, 0x01, 0x00, "Pre-2.0 PCI Specification Device", "VGA Compatible", "" } ,

	{ 0x01, 0x00, 0x00, "Mass Storage Controller", "SCSI", "" } ,
	{ 0x01, 0x01, 0x00, "Mass Storage Controller", "IDE", "" } ,
	{ 0x01, 0x01, 0x8A, "Mass Storage Controller", "IDE", "AMD" } ,
	{ 0x01, 0x02, 0x00, "Mass Storage Controller", "Floppy", "" } ,
	{ 0x01, 0x03, 0x00, "Mass Storage Controller", "IPI", "" } ,
	{ 0x01, 0x04, 0x00, "Mass Storage Controller", "RAID", "" } ,
	{ 0x01, 0x05, 0x20, "Mass Storage Controller", "ATA-Controller (Single  DMA)", "" } ,
	{ 0x01, 0x05, 0x30, "Mass Storage Controller", "ATA-Controller (Chained DMA) ", "" } , 	   
	{ 0x01, 0x80, 0x00, "Mass Storage Controller", "Other", "" } ,

	{ 0x02, 0x00, 0x00, "Network Controller", "Ethernet", "" } ,
	{ 0x02, 0x01, 0x00, "Network Controller", "Token Ring", "" } ,
	{ 0x02, 0x02, 0x00, "Network Controller", "FDDI", "" } ,
	{ 0x02, 0x03, 0x00, "Network Controller", "ATM", "" } ,
	{ 0x02, 0x80, 0x00, "Network Controller", "Other", "" } ,
	{ 0x02, 0x04, 0x00, "Network Controller", "ISDN", "" } ,
	{ 0x02, 0x05, 0x00, "Network Controller", "World FIP (Feldbus)", "" } ,
	{ 0x02, 0x06, 0x00, "Network Controller", "PICMG 2.14, Multi-Computing ", "" } ,

	{ 0x03, 0x00, 0x00, "Display Controller", "PC Compatible", "VGA" } ,
	{ 0x03, 0x00, 0x01, "Display Controller", "PC Compatible", "8514" } ,
	{ 0x03, 0x01, 0x00, "Display Controller", "XGA", "" } ,
	{ 0x03, 0x80, 0x00, "Display Controller", "Other", "" } ,
    { 0x03, 0x02, 0x00, "Display Controller", "3D", "" } ,

	{ 0x04, 0x00, 0x00, "Multimedia Device", "Video", "" } ,
	{ 0x04, 0x01, 0x00, "Multimedia Device", "Audio", "" } ,
	{ 0x04, 0x02, 0x00, "Multimedia Device", "Telefonie", "" } ,
	
	{ 0x04, 0x80, 0x00, "Multimedia Device", "Other", "" } ,

	{ 0x05, 0x00, 0x00, "Memory Controller", "RAM", "" } ,
	{ 0x05, 0x01, 0x00, "Memory Controller", "Flash", "" } ,
	{ 0x05, 0x80, 0x00, "Memory Controller", "Other", "" } ,

	{ 0x06, 0x00, 0x00, "Bridge Device", "Host/PCI", "" } ,
	{ 0x06, 0x01, 0x00, "Bridge Device", "PCI/ISA", "" } ,
	{ 0x06, 0x02, 0x00, "Bridge Device", "PCI/EISA", "" } ,
	{ 0x06, 0x03, 0x00, "Bridge Device", "PCI/Micro Channel", "" } ,
	{ 0x06, 0x04, 0x00, "Bridge Device", "PCI/PCI", "" } ,
	{ 0x06, 0x04, 0x01, "Bridge Device", "PCI/PCI", "AMD" } ,
	{ 0x06, 0x05, 0x00, "Bridge Device", "PCI/PCMCIA", "" } ,
	{ 0x06, 0x06, 0x00, "Bridge Device", "PCI/NuBus", "" } ,
	{ 0x06, 0x07, 0x00, "Bridge Device", "PCI/CardBus", "" } ,
	{ 0x06, 0x80, 0x00, "Bridge Device", "Other", "" } ,
	
	{ 0x06, 0x08, 0x00, "Bridge Device", "Raceway, Switched Fabric", "" } ,
	{ 0x06, 0x09, 0x40, "Bridge Device", "Semitransparente PCI/PCI-Bridge (primr zum Host)", "" } ,
	{ 0x06, 0x09, 0x80, "Bridge Device", "Semitransparente PCI/PCI-Bridge (sekundr zum Host)", "" } ,
	{ 0x06, 0x0A, 0x00, "Bridge Device", "InfiniBand/PCI-Brige ", "" } ,


	{ 0x07, 0x00, 0x00, "Simple Communications Controller", "Serial", "Generic XT Compatible" } ,
	{ 0x07, 0x00, 0x01, "Simple Communications Controller", "Serial", "16450 Compatible" } ,
	{ 0x07, 0x00, 0x02, "Simple Communications Controller", "Serial", "16550 Compatible" } ,
	
	{ 0x07, 0x00, 0x03, "Simple Communications Controller", "Serial", "16650 Compatible" } ,
	{ 0x07, 0x00, 0x04, "Simple Communications Controller", "Serial", "16750 Compatible" } ,
	{ 0x07, 0x00, 0x05, "Simple Communications Controller", "Serial", "16850 Compatible" } ,
	{ 0x07, 0x00, 0x06, "Simple Communications Controller", "Serial", "16950 Compatible" } ,
	
	{ 0x07, 0x01, 0x00, "Simple Communications Controller", "Parallel", "Standard" } ,
	{ 0x07, 0x01, 0x01, "Simple Communications Controller", "Parallel", "Bidirectional" } ,
	{ 0x07, 0x01, 0x02, "Simple Communications Controller", "Parallel", "ECP 1.X Compliant" } ,
	{ 0x07, 0x01, 0x03, "Simple Communications Controller", "Parallel", "Parallelport (IEEE 1284)" } ,
	{ 0x07, 0x01, 0xFE, "Simple Communications Controller", "Parallel", "IEEE-1284-Gert, Target" } ,

	{ 0x07, 0x02, 0x00, "Simple Communications Controller", "", "Multiport Serial Controller" } ,
	{ 0x07, 0x03, 0x00, "Simple Communications Controller", "", "Standard-Modem" } ,
	{ 0x07, 0x03, 0x01, "Simple Communications Controller", "", "Hayes-kompatibles Modem (16450)" } ,
	{ 0x07, 0x04, 0x00, "Simple Communications Controller", "", "GPIB (IEEE488.1/2) Controller" } ,
	{ 0x07, 0x04, 0x02, "Simple Communications Controller", "", "Hayes-kompatibles Modem (16550)" } ,
	{ 0x07, 0x04, 0x03, "Simple Communications Controller", "", "Hayes-kompatibles Modem (16650)" } ,
	{ 0x07, 0x04, 0x04, "Simple Communications Controller", "", "Hayes-kompatibles Modem (16750)" } ,
	{ 0x07, 0x05, 0x00, "Simple Communications Controller", "", "SmartCard" } ,
	{ 0x07, 0x80, 0x00, "Simple Communications Controller", "", "Anderer Controller " } ,
	
	{ 0x07, 0x80, 0x02, "Simple Communications Controller", "Other", "" } ,


	{ 0x08, 0x00, 0x00, "Base Systems Peripheral", "PIC (Programmable Interrupt Controller)", "Generic 8259" } ,
	{ 0x08, 0x00, 0x01, "Base Systems Peripheral", "PIC (Programmable Interrupt Controller)", "ISA" } ,
	{ 0x08, 0x00, 0x02, "Base Systems Peripheral", "PIC (Programmable Interrupt Controller)", "PCI" } ,
	{ 0x08, 0x00, 0x10, "Base Systems Peripheral", "IO- APIC (EISA)", "" } ,
	{ 0x08, 0x00, 0x20, "Base Systems Peripheral", "IOx-APIC", "" } ,
	{ 0x08, 0x01, 0x00, "Base Systems Peripheral", "DMA (Direct Memory Access)", "Generic 8259" } ,
	{ 0x08, 0x01, 0x01, "Base Systems Peripheral", "DMA (Direct Memory Access)", "ISA" } ,
	{ 0x08, 0x01, 0x02, "Base Systems Peripheral", "DMA (Direct Memory Access)", "EISA" } ,
	{ 0x08, 0x02, 0x00, "Base Systems Peripheral", "System Timer", "Generic 8259" } ,
	{ 0x08, 0x02, 0x01, "Base Systems Peripheral", "System Timer", "ISA" } ,
	{ 0x08, 0x02, 0x02, "Base Systems Peripheral", "System Timer", "EISA" } ,
	{ 0x08, 0x03, 0x00, "Base Systems Peripheral", "RTC (Real Time Clock)", "Generic" } ,
	{ 0x08, 0x03, 0x01, "Base Systems Peripheral", "RTC (Real Time Clock)", "ISA" } ,
	{ 0x08, 0x04, 0x00, "Base Systems Peripheral", "PCI Hot Plug Controller", "" } ,
	{ 0x08, 0x80, 0x00, "Base Systems Peripheral", "Other", "" } ,

	{ 0x09, 0x00, 0x00, "Input Device", "Keyboard", "" } ,
	{ 0x09, 0x01, 0x00, "Input Device", "Digitizer (Pen)", "" } ,
	{ 0x09, 0x02, 0x00, "Input Device", "Mouse", "" } ,
	{ 0x09, 0x03, 0x00, "Input Device", "Scanner", "" } ,
	{ 0x09, 0x04, 0x00, "Input Device", "Standard-Gameport", "" } ,
	{ 0x09, 0x04, 0x10, "Input Device", "Gameport", "" } ,
	{ 0x09, 0x80, 0x00, "Input Device", "Other", "" } ,


	{ 0x0A, 0x00, 0x00, "Docking Station", "Generic", "" } ,
	{ 0x0A, 0x80, 0x00, "Docking Station", "Other", "" } ,


	{ 0x0B, 0x00, 0x00, "Processor", "i386", "" } ,
	{ 0x0B, 0x01, 0x00, "Processor", "i486", "" } ,
	{ 0x0B, 0x02, 0x00, "Processor", "Pentium", "" } ,
	{ 0x0B, 0x10, 0x00, "Processor", "Alpha", "" } ,
	{ 0x0B, 0x20, 0x00, "Processor", "Power PC", "" } ,
	{ 0x0B, 0x80, 0x00, "Processor", "Co-processor", "" } ,


	{ 0x0C, 0x00, 0x00, "Serial Bus Controller", "Firewire (IEEE 1394)", "" } ,
	{ 0x0C, 0x01, 0x00, "Serial Bus Controller", "ACCESS.bus", "" } ,
	{ 0x0C, 0x02, 0x00, "Serial Bus Controller", "SSA (Serial Storage Archetecture)", "" } ,
	{ 0x0C, 0x03, 0x00, "Serial Bus Controller", "USB (Universal Serial Bus)", "" } ,
	{ 0x0C, 0x03, 0x10, "Serial Bus Controller", "USB (Universal Serial Bus)", "AMD" } ,
	{ 0x0C, 0x04, 0x00, "Serial Bus Controller", "Fibre Channel", "" } ,
    { 0x0C, 0x05, 0x00, "Serial Bus Controller", "SMB (System Management Bus)", "" } ,
    { 0x0C, 0x06, 0x00, "Serial Bus Controller", "InfiniBand", "" } ,
    { 0x0C, 0x07, 0x00, "Serial Bus Controller", "IPMI SMIC Interface", "" } ,
    { 0x0C, 0x07, 0x01, "Serial Bus Controller", "IPMI Keyboard Style Interface", "" } ,
    { 0x0C, 0x07, 0x02, "Serial Bus Controller", "IPMI Block Transfer Device", "" } ,
    { 0x0C, 0x08, 0x00, "Serial Bus Controller", "SERCOS Interface", "" } ,
    { 0x0C, 0x09, 0x00, "Serial Bus Controller", "CAN-Bus", "" } , 
    
    { 0x0D, 0x00, 0x00, "Wireless-Controller", "iRDA", "" } , 
    { 0x0D, 0x01, 0x00, "Wireless-Controller", "Radio Frequency", "" } , 
    { 0x0D, 0x11, 0x00, "Wireless-Controller", "Bluetooth", "" } , 
    { 0x0D, 0x12, 0x00, "Wireless-Controller", "Broadband", "" } , 
    { 0x0D, 0x80, 0x00, "Wireless-Controller", "Anderer Wireless-Controller ", "" } , 

    { 0x0E, 0x00, 0x00, "Intelligente Controller ", "IO-Architektur ", "" } , 
    { 0x0E, 0x00, 0x00, "Intelligente Controller ", "Message FIFO ", "" } , 
    
	{ 0xFF, 0x00, 0x00, "Unknown", "Device Does Not Fit In Class Codes", "UDF" } ,
} ;
// Use this value for loop control during searching:
#define	PCI_CLASSCODETABLE_LEN	(sizeof(PciClassCodeTable)/sizeof(PCI_CLASSCODETABLE))


#endif
