#include "smbus.h"
#define TIMEOUT 0x2000

unsigned int SMBus_adresse=0;


unsigned int Get_SMBus_Adress(void)
{
    if (SMBus_adresse==0)
    {
    	unsigned int i=PCI_adresse;
    	unsigned int Adresse = 0;
    	unsigned int PCI_Data =0;
    	unsigned int Device_class =0;
    	unsigned int SMBUS_adresse =0;
    	unsigned int ii=0;
    	for(i=PCI_adresse;i<PCI_End_adresse;i=i+PCI_Count_ad)
    	{
    		Adresse=i & 0xFFFFFF00;
    		PortDWordOut (Adress_port, Adresse);
    		PCI_Data = PortDWordIn(Data_port);
    		if (PCI_Data != 0x0FFFFFFFF)
    		{
    			
    			switch (PCI_Data)
    			{
    				case VDID_PIIX4:
    					PortDWordOut (Adress_port, Adresse + 0x90);
    					SMBUS_adresse = PortDWordIn(Data_port);
                        break;
    				case VDID_VIA596A:
    					PortDWordOut (Adress_port, Adresse + 0x80);
    					SMBUS_adresse = PortDWordIn(Data_port);
                        break;
    				case VDID_VIA686A:
    					PortDWordOut (Adress_port, Adresse + 0x90);
    					SMBUS_adresse = PortDWordIn(Data_port);
                        break;
    				case VDID_AMD756PM:
    					PortDWordOut (Adress_port, Adresse + 0x58);
    					SMBUS_adresse = PortDWordIn(Data_port);
                        break;
    				case VDID_AMD766PM:
    					PortDWordOut (Adress_port, Adresse + 0x58);
    					SMBUS_adresse = PortDWordIn(Data_port);
                        break;
    				case VDID_AMD768PM:
    					PortDWordOut (Adress_port, Adresse + 0x58);
    					SMBUS_adresse = PortDWordIn(Data_port);
                        break;
    				case VDID_AMD8111PM:
    					PortDWordOut (Adress_port, Adresse + 0x58);
    					SMBUS_adresse = PortDWordIn(Data_port);
                        break;
                    case ATI_SMBus:
                         for(ii=0x10;ii<0x24;ii=ii+0x4)
    				     {
    
    					       PortDWordOut (Adress_port, Adresse + ii);
    					       SMBUS_adresse = PortDWordIn(Data_port);
    					       if(SMBUS_adresse) break;
                         }
                         break;
    			}
    			if(SMBUS_adresse) break;
    			PortDWordOut (Adress_port, Adresse + 0x8);
    			Device_class = PortDWordIn(Data_port);
    			Device_class=(Device_class>>8);
    			//printf("%x\n",Device_class);
    			if(Device_class==0xC0500)
    			{
    				for(ii=0x10;ii<0x24;ii=ii+0x4)
    				{
    					 PortDWordOut (Adress_port, Adresse + ii);
    					 SMBUS_adresse = PortDWordIn(Data_port);
    					 //printf("%x\n",SMBUS_adresse);
    					 if(SMBUS_adresse) break;
    				}
    			}
    		}
    		
    	}
    	
	SMBus_adresse=(unsigned int)(SMBUS_adresse & 0x0FFF0);
    }
    
	return SMBus_adresse;
}




unsigned char ReadshortSMBus(unsigned int SMBus_port,unsigned char device_nummer,unsigned char cmmd,unsigned short *data)
{
     unsigned short daten=0;
     char  value=0;
	 int i=0;
	 char Device;
     char ret=0;
     unsigned long timeout=TIMEOUT;
    
	 Device=(device_nummer<<1);
	 Device=Device | 1;

	 PortOut(SMBus_port+4,Device);//device 7:1,read/write 0:0 -> 1=read
	 NEWIODELAY();
	 
	 PortOut(SMBus_port+3,cmmd);//device command 
	 NEWIODELAY();
	 
	 PortOut(SMBus_port+2,0x4C);//01001100b ;START=1 SMB_CMD =010b Byte Data 
	 NEWIODELAY();
	 
	 while(timeout)
	{
         NEWIODELAY();
		 
         value = PortIn(SMBus_port);   
         timeout--;
         if(value & 2)
             break;                   
    }
    if (timeout==0)
    {
            unsigned char status=0;
            status = PortIn(SMBus_port);
            if((status & 0x4)||(status & 0x1))
            {
                PortOut(SMBus_port+2,2);//killbit
                value = PortIn(SMBus_port);
                NEWIODELAY();
                PortOut(SMBus_port,value);
                
                
                NEWIODELAY();
                daten = PortIn(SMBus_port+6);
                NEWIODELAY();
                daten = PortIn(SMBus_port+5);
                NEWIODELAY();
                if(value & 0x4)
                     return 1;
                if (value & 0x1)
                     return 2;
                       
            }
            
            
    }
    if(wait_busy(SMBus_port,65535))
    {
          value = PortIn(SMBus_port);
          NEWIODELAY();
          PortOut(SMBus_port,value);
          NEWIODELAY();
          daten = PortIn(SMBus_port+6);
          NEWIODELAY();
          daten = PortIn(SMBus_port+5);
          return 3;
    }
            
    value = PortIn(SMBus_port);
    if(value & 0x4)
          ret=4;
    NEWIODELAY();
    PortOut(SMBus_port,value);
    
    daten = PortIn(SMBus_port+6); 
    daten=daten<<8;
    daten=daten | PortIn(SMBus_port+5);    
     
    
    
    *data=daten;
	return ret;    
}


unsigned char ReadByteSMBus(unsigned int SMBus_port,unsigned char device_nummer,unsigned char cmmd,unsigned char *data)
{
     unsigned char value=0;
     unsigned char daten=0;
	 unsigned char i=0;
	 unsigned char Device;
     unsigned char ret=0;
     unsigned long timeout=0x1000;
    
	 Device=(device_nummer<<1);
	 Device=Device | 1;

	 PortOut(SMBus_port+4,Device);//device 7:1,read/write 0:0 -> 1=read
	 NEWIODELAY();
	 
	 PortOut(SMBus_port+3,cmmd);//device command 
	 NEWIODELAY();
	 
	 PortOut(SMBus_port+2,0x48);//01001000b ;START=1 SMB_CMD =010b Byte Data 
	 NEWIODELAY();
	 
            
     while(timeout)
	{
         NEWIODELAY();
		 
         value = PortIn(SMBus_port);   
         timeout--;
         if(value & 2)
             break;                   
    }
    if (timeout==0)
    {
            unsigned char status=0;
            status = PortIn(SMBus_port);
            if((status & 0x4)||(status & 0x1))
            {
                PortOut(SMBus_port+2,2);//killbit
                value = PortIn(SMBus_port);
                NEWIODELAY();
                PortOut(SMBus_port,value);
                
                
                NEWIODELAY();
                daten = PortIn(SMBus_port+5);
                
                NEWIODELAY();
                if(value & 0x4)
                     return 1;
                if (value & 0x1)
                     return 2;
                       
            }
            
            
    }
    if(wait_busy(SMBus_port,65535))
    {
          value = PortIn(SMBus_port);
          NEWIODELAY();
          PortOut(SMBus_port,value);
          NEWIODELAY();
          daten = PortIn(SMBus_port+5);
          return 3;
    }
    
    value = PortIn(SMBus_port);
    if(value & 0x4)
          ret=4;
    NEWIODELAY();
    PortOut(SMBus_port,value);
    
    NEWIODELAY();
    daten = PortIn(SMBus_port+5);
    
    NEWIODELAY();
       
    *data=daten;
    return ret;   
}


unsigned char sm_get_statusregister(unsigned int SMBus_port)
{
         return PortIn(SMBus_port);
}



char wait_busy(unsigned int SMBus_port,unsigned long timm)
{
     unsigned long timeout=timm;
     
     while(timeout)
     {
            NEWIODELAY();
            if(!(PortIn(SMBus_port) & 0x1))
                   break;
            timeout--;
     }
     if(timeout==0)
           return 1;
     return 0;    
     
}
